using Gtk;


namespace Eidete.Widgets {
	
	public class EndDialog : Window {
		public EndDialog (EideteApp app){
			var grid = new Grid ();
			grid.margin = 12;
			
			var title = new Label ("<span size='30000'>Recording done</span>");
			title.use_markup = true;
			title.halign = Align.START;
			var sub_title = new Label ("<span size='15000'>And now?</span>");
			sub_title.use_markup = true;
			sub_title.halign = Align.START;
			
			var save = new Button.from_stock (Stock.SAVE);
			save.set_halign (Align.END);
			
			var trash = new Button.with_label ("Trash it");
			trash.image = new Image.from_stock (Stock.DELETE, IconSize.BUTTON);
			trash.set_halign (Align.START);
			
			grid.attach (title, 0, 0, 2, 1);
			grid.attach (sub_title, 0, 1, 2, 1);
			grid.attach (new Label (""), 0, 2, 1, 1);
			grid.attach (save, 0, 3, 1, 1);
			grid.attach (trash, 1, 3, 1, 1);
			
			
			save.clicked.connect ( () => {
				var filter = new FileFilter ();
				filter.add_mime_type ("video/webm");
				var file = new FileChooserDialog ("Choose destination", this, 
				     FileChooserAction.SAVE, Stock.CANCEL, ResponseType.CANCEL, Stock.OK, ResponseType.OK);
				file.filter = filter;
				file.do_overwrite_confirmation = true;
				file.set_current_name ("Untitled.webm");
				var res = file.run ();
				if (res == ResponseType.OK){
					this.save (app.settings.destination, file.get_filename ());
					file.destroy ();
					this.destroy ();
				}else{
					file.destroy ();
				}
			});
			
			trash.clicked.connect ( () => {this.destroy ();});
			
			this.add (grid);
			this.destroy.connect (Gtk.main_quit);
		}
		
		
		private void save (string tmp, string dest){
			var source      = File.new_for_path (tmp);
			var destination = File.new_for_path (dest);
			try{
				source.copy (destination, FileCopyFlags.NONE);
			}catch (GLib.Error e){stderr.printf ("Error: %s\n", e.message);}
		}
	}
	
}


