using Granite;
using Gtk;


namespace Eidete.Widgets {
	
	
	public class KeyView : Granite.Widgets.CompositedWindow{
		
		public Label key;
		public int x;
		public int y;
		public bool alpha;
		
		public bool ctrl;
		public bool shift;
		public bool alt;
		
		[CCode (cname = "intercept_key_thread")]
		public extern void *intercept_key_thread ();
		
		public signal void captured (string keyvalue, bool released);
		
		public KeyView (){
			this.key = new Label ("");
			this.key.use_markup = true;
			this.add (key);
			this.set_size_request (100, 100);
			this.resize (100, 100);
			this.set_keep_above (true);
			this.stick ();
			
			this.enter_notify_event.connect ( () => {
				Cairo.RectangleInt rect = {0, 0, 1, 1};
				this.get_window ().input_shape_combine_region (new Cairo.Region.rectangle (rect), 0, 0);
				return true;
			});
			
			capture ();
			
			this.captured.connect ( (keyvalue, released) => {
				if (released){
					switch (keyvalue){
						case "Control_L":
						case "Control_R":
							this.ctrl = false;break;
						case "Shift_L":
						case "Shift_R":
							this.shift = false;break;
						case "Alt_L":
						case "Alt_R":
							this.alt = false;break;
					}
				}else{
					place (x, y);
					string res = keyvalue;
					switch (keyvalue){
						case "Control_L":
						case "Control_R":
							ctrl = true; return;
						case "Shift_L":
						case "Shift_R":
							shift = true; return;
						case "Alt_L":
						case "Alt_R":
							alt = true; return;
						case "Escape":
							res = "Esc"; break;
						case "Return":
							res = "Ret"; break;
						case "Delete":
							res = "Del"; break;
						case "comma":
							res = ","; break;
						case "period":
							res = "."; break;
						case "minus":
							res = "-"; break;
						case "BackSpace":
							res = "←"; break; //TODO
						case "Left":
							res = "◄"; break;
						case "Right":
							res = "►"; break;
						case "Up":
							res = "▲"; break;
						case "Down":
							res = "▼"; break;
						default:
							if (keyvalue.length > 9)
								res = keyvalue.substring (0, 9);
							break;
					}
					
					res = "<span size='30000' color='#ffffff'>"+res+"</span>";
					string modifiers = "";
					
					if (this.ctrl && (keyvalue != "Control_L") && (keyvalue != "Control_R"))
						modifiers += "<span size='20000' color='#ffffff'>Ctrl+</span>";
					if (this.shift && (keyvalue != "Shift_L") && (keyvalue != "Shift_R"))
						modifiers = "<span size='20000' color='#ffffff'>Shft+</span>";
					if (this.alt && (keyvalue != "Alt_L") && (keyvalue != "Alt_R"))
						modifiers = "<span size='20000' color='#ffffff'>Alt+</span>";
					this.key.label = modifiers+res;
				}
			});
		}
		
		public override bool draw (Cairo.Context ctx){
			int w = this.get_allocated_width  ();
			int h = this.get_allocated_height ();
			Granite.Drawing.Utilities.cairo_rounded_rectangle (ctx, 4, 4, w-8, h-8, 4);
			ctx.set_source_rgba (0.1, 0.1, 0.1, 0.5);
			ctx.fill ();
			return base.draw (ctx);
		}
		
		public void place (int x, int y){
			this.x = x;
			this.y = y;
			this.move (x, y);
		}
		
		public void capture (){
			try{
				Thread.create<void*> (this.intercept_key_thread, true);
			}catch (ThreadError e){stderr.printf (e.message);}
		}
	}
	
	
	
}
