#include <stdio.h>
#include <glib.h>
#include <X11/Xproto.h>
#include <X11/Xlib.h>
#include <X11/extensions/record.h> //libxtst-dev, Xtst

static Display* dpy = 0;
static XRecordContext rc;


void key_pressed_cb(XPointer arg, XRecordInterceptData *d) {
	if (d->category != XRecordFromServer) return;
	unsigned char type = ((unsigned char*)d->data)[0] & 0x7F;
	unsigned char detail = ((unsigned char*)d->data)[1];
	
	if (type == KeyPress) {
		g_signal_emit_by_name (arg, "captured", XKeysymToString (XKeycodeToKeysym (dpy, detail, 0)), FALSE);
	}else if (type == KeyRelease){
		g_signal_emit_by_name (arg, "captured", XKeysymToString (XKeycodeToKeysym (dpy, detail, 0)), TRUE);
	}
}

void* intercept_key_thread(void *data) {
	XRecordClientSpec rcs;
	XRecordRange* rr;
	dpy = XOpenDisplay (0);
	
	XKeysymToString (XKeycodeToKeysym (dpy, 11, 1));
	
	if (!(rr = XRecordAllocRange())) {
		fprintf(stderr, "XRecordAllocRange error\n");
	}
	rr->device_events.first = KeyPress;
	rr->device_events.last = MotionNotify;
	rcs = XRecordAllClients;
	
	if (!(rc = XRecordCreateContext(dpy, 0, &rcs, 1, &rr, 1))) {
		fprintf(stderr, "XRecordCreateContext error\n");
	}
	XFree(rr);
	if (!XRecordEnableContext(dpy, rc, key_pressed_cb, data)) {
		fprintf(stderr, "XRecordEnableContext error\n");
	}
	return 0;
}

